var numbers = [];

$(document).ready(function () {
    noticer = new Noticer;

    $("button").button();
    $("#tabs").tabs();

    $("#update").button("option", "icon", "ui-icon-refresh");
    $("#add-number").button("option", "icon", "ui-icon-plusthick");
    $("#logout").button("option", "icon", "ui-icon-power");

    // За каждым индексом закреплена функция для выполнения действия
    // на активной вкладке при нажатии на кнопку обновления
    $("#update").click(() => {
        ({
            0: () => { generateGroupNumbers($("#accordion-numbers .ui-accordion-content-active")) },
            1: () => { noticer.success('Вкладка "SMS"') },
            2: () => { noticer.success('Вкладка "USSD"') },
            3: () => { noticer.success('Вкладка "Сервер"') }
        })[$("#tabs").tabs( "option", "active" )]()
    });

    $("#add-number").click(() => {
        addNumber($("#accordion-numbers .ui-accordion-content-active"))
    });

    $("body").fadeTo(500, 1);

    $("#search").on("input", function () {
        showNumbers(
            $("#accordion-numbers .ui-accordion-content-active"),
            numbers.filter(e => e.number.includes($(this).val()))
        )
    }).keydown(function (e) {
        e.key == "Escape" && ($(this).val(""), showNumbers($("#accordion-numbers .ui-accordion-content-active")))
    });

    loadData();
})

async function request(query, type, queryData = {}) {
    let response = await fetch('.', {
        method: 'POST',
        headers: {
            'Content-Type': 'application/json;charset=utf-8'
        },
        body: JSON.stringify({
            ...queryData, 
            query: query
        })
    });

    if (!response.ok)
        throw new Error(`Произошла неизвестаня ошибка: ${response.status}`);
    
    const data = await response[type]();
    return data;
}

function isJSON(str) {
    try {
        return (JSON.parse(str) && !!str);
    } catch (e) {
        return false;
    }
}

function loadData() {
    request('listsgroups', 'text').then(data => {
        data.error ? noticer.error(data.message) : generateListsGroups(data);
    }).catch(error => {
        noticer.error(error.message);
    });
}

function generateListsGroups(data) {
    $("#tabs-numbers").html(data);
    $("#accordion-numbers").accordion({
        heightStyle: "content",
        create: function( event, ui ) {
            generateGroupNumbers(ui.panel);
        },
        beforeActivate: function( event, ui ) {
            generateGroupNumbers(ui.newPanel);
        }
    });
}

function generateGroupNumbers(panel) {
    request('groupnumbers', 'json', { group: panel.data("group-name") }).then(data => {
        if (isJSON(data) && JSON.parse(data).error)
            noticer.error(JSON.parse(data).message);
        else {
            numbers = data;
            showNumbers(panel);
        }
    }).catch(error => {
        noticer.error(error.message);
    });
}

function showNumbers(panel, data = numbers.filter(e => e.number.includes($("#search").val()))) {
    (new divNotFoundNumbers).remove();
    let body = panel.find('.body').html('');
    $(data).each((i, j) => {
        let row = $(`<tr class="row" data-number="${j.number}"></tr>`);
        row.append(`<td>${j.number}</td>`);
        row.append(`<td>${j.list}</td>`);
        row.append(`<td>${j.all_cc}</td>`);
        row.append(`<td>${j.white_cc}</td>`);
        row.append(`<td>${j.black_cc}</td>`);
        row.append(`<td>${j.comment}</td>`);
        body.append(row);

        row.click(function() {
            editNumber(panel, $(this).data('number'));
        });        
    });

    if (!body.children().length)
        (new divNotFoundNumbers).push();
}


function divNotFoundNumbers() {
    let notFound = $('.failNumbers');
    let divTable = $('.body-rows');
    let divFound = $('<div class="failNumbers"></div>');

    divFound.css({
        "color": "#333",
        "text-align": "center",
        "padding": "20px 0 20px 0"
    });

    this.push = function(text = 'Нет номеров') {
        divTable.append(divFound.html(text));
    }

    this.remove = function() {
        notFound.remove();
    }
}

function editNumber(panel, number) {
    request('editnumber', 'text', {number: number}).then(data => {
        if (isJSON(data) && JSON.parse(data).error)
            noticer.error(JSON.parse(data).message);
        else {
            showEditNumber(data, [
                {
                    id: "btn-save",
                    text: "Сохранить",
                    icon: "ui-icon-check",
                    click: function() {
                        actionNumber(panel, $(this), 'updatenumber');
                    }
                },
                {
                    id: "btn-delete",
                    text: "Удалить",
                    icon: "ui-icon-trash",
                    click: function() {
                        delNumber(panel, $(this));
                    }
                }
            ], `Редактирование номера ${number}`);
        }
    }).catch(error => {
        noticer.error(error.message);
    });
}

function showEditNumber(data, actionButton, title) {
    let form = $(data);

    form.appendTo('body').dialog({
        title: title,
        height: 'auto',
        width: 'auto',
        resizable: false,
        modal: true,
        show: { effect: "fade", duration: 500 },
        close: function(event, ui) {
            $(this).dialog('destroy').remove()
        },
        buttons: [
            ...actionButton,
            {
                text: "Отмена",
                icon: "ui-icon-cancel",
                click: function() {
                    $(this).dialog("close");
                }
            }
        ]
    });

    $('#number-group, #number-list').selectmenu({
        width: 200
    });
}

function actionNumber(panel, currentWindow, query) {
    // Только числа, начинающие с >0 или только 0
    let regexp = /^(?=\d)(\d|([^0]\d+))$/g;

    let number = $('#number-number').val();
    let group = $('#number-group').val();
    let list = $('#number-list').val();
    let all_cc = $('#number-all-cc').val();
    let white_cc = $('#number-white-cc').val();
    let black_cc = $('#number-black-cc').val();
    let comment = $('#number-comment').val();

    let error = false;

    if (!number.length) { noticer.warning('Номер не может быть пуст'); error = true; }
    if (all_cc.match(regexp) === null) { noticer.warning("Не верно указано общее количество звонков"); error = true; }
    if (white_cc.match(regexp) === null) { noticer.warning("Не верно указано белое количество звонков"); error = true; }
    if (black_cc.match(regexp) === null) { noticer.warning("Не верно указано черное количество звонков"); error = true; }

    if (error) return;

    request(query, 'json', {
        number: number,
        group: group,
        list: list,
        all_cc: parseInt(all_cc),
        white_cc: parseInt(white_cc),
        black_cc: parseInt(black_cc),
        comment: comment
    }).then(data => {
        if (data.error)
            noticer.error(data.message);
        else
        {
            query == 'write' ? noticer.success(`Номер ${number} был добавлен`) : noticer.success(`Номер ${number} был обновлен`);
            generateGroupNumbers(panel);
            currentWindow.dialog("close");
        }
    }).catch(error => {
        noticer.error(error.message);
    });
}

function addNumber(panel) {
    request('addnumber', 'text', { group: panel.data("group-name") }).then(data => {
        if (isJSON(data) && JSON.parse(data).error)
            noticer.error(JSON.parse(data).message);
        else {
            showEditNumber(data, [{
                id: "btnSave",
                text: "Добавить",
                icon: "ui-icon-check",
                click: function() {
                    actionNumber(panel, $(this), 'writenumber');
                }
            }], "Добавление нового номера");
        }
    }).catch(error => {
        noticer.error(error.message);
    });
}

function delNumber(panel, currentWindow) {
    let number = $('#number-number').val();

    let error = false;
    if (!number.length) { noticer.warning('Номер не может быть пуст'); error = true; }
    if (error) return;

    request('delnumber', 'json', {
        number: number
    }).then(data => {
        if (data.error)
            noticer.error(data.message);
        else {
            noticer.success(`Номер ${number} был удален`);
            generateGroupNumbers(panel);
            currentWindow.dialog("close");
        }
    }).catch(error => {
        noticer.error(error.message);
    });
}
